###############################################################################
## Arcadia Project
##
## Copyright (C) 2009-2010 Arcadia Project arcadia.videogame@gmail.com http://www.arcadiaproject.org/
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 3 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
###############################################################################

import xml.parsers.expat
import re

#TODO: TEMPORTAL PRUEBA UNITARIA


class Parser:

    def __init__(self):

        self.actualLvl=0
        self.tmpName=["","","","",""] 
        self.tmpLvl=[{},{},{},{},{}]
        self.results=[]

        self.tmpContent=""



    def startMarkUp(self, name, attributes):
        name=str(name)
        self.actualLvl=self.actualLvl+1

        self.tmpContent=0
        self.tmpLvl[self.actualLvl-1]={}


        if (self.actualLvl<=len(self.tmpName)):
            self.tmpName[self.actualLvl-1]=name



    def content(self,data):

        dataStr=str(data)
        self.tmpContent=dataStr


    def endMarkUp(self,name):
        name=str(name)

        if self.tmpContent<>0:
            self.tmpLvl[self.actualLvl-2][self.tmpName[self.actualLvl-1]]=self.tmpContent
            self.tmpContent=0
        elif (self.actualLvl-1)==0:
            self.results.append({self.tmpName[self.actualLvl-1]:self.tmpLvl[self.actualLvl-1]})
        else:

            if type(self.tmpLvl[self.actualLvl-2]=='dict'):
                saveContent=self.tmpLvl[self.actualLvl-2].get(self.tmpName[self.actualLvl-1])
            else:
                saveContent=self.tmpLvl[self.actualLvl-2][self.tmpName[self.actualLvl-1]]

            if saveContent=="" or saveContent=={} or saveContent==None:
                self.tmpLvl[self.actualLvl-2][self.tmpName[self.actualLvl-1]]=self.tmpLvl[self.actualLvl-1]

            else:
                nameGen=0
                while (saveContent<>"" and saveContent<>{} and saveContent<>None):                                
                    nameGen=nameGen+1
                    if (self.tmpLvl[self.actualLvl-2]=='dict'):
                        saveContent=self.tmpLvl[self.actualLvl-2].get(str(self.tmpName[self.actualLvl-1])+str(nameGen))
                    else:
                        break

                self.tmpLvl[self.actualLvl-2][str(self.tmpName[self.actualLvl-1])+str(nameGen)]=self.tmpLvl[self.actualLvl-1]

        if (self.actualLvl>0):
            self.actualLvl=self.actualLvl-1
        else:
            return -1
 
        



    

    def startParser(self,string):

        p = xml.parsers.expat.ParserCreate()

        p.StartElementHandler = self.startMarkUp
        p.EndElementHandler = self.endMarkUp
        p.CharacterDataHandler = self.content
    
        newString=self.cleanString(string)

        try:
            p.Parse(newString, 1) 

        except xml.parsers.expat.ExpatError:
            print "The file is not valid" #TODO
            return -1
        return self.results


    def cleanString(self,string):

            result=string
          
            if re.search(r'[\r\n\t]+', result):
                result=re.subn(r'[\r\n\t]+', r'', result)[0]

            if re.search(r'>\s+', result):
                result=re.subn(r'>\s+', r'>', result)[0]

            if re.search(r'\s+<', result):
                result=re.subn(r'\s+<', r'<', result)[0]

            return result

            

if __name__=="__main__":

    prueba = Parser()
 
    prueba.startParser("""<config>
           <name>Menu inicio </name>
           <menu>
               <button>
                    <function>comenzarJuego()</function>
                    <name>Inicio</name>
               </button>
               <button>
                    <function>configuracion()</function>
                    <name>Configuracion</name>
              </button>
           </menu>
        </config>""")
    
    print prueba.results



