###############################################################################
## Arcadia Project
##
## Copyright (C) 2009-2010 Arcadia Project arcadia.videogame@gmail.com http://www.arcadiaproject.org/
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 3 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
###############################################################################

import pygame
from pygame.locals import *
from lib.SpriteManager import SpriteManager

screen_width = 1024
screen_height = 600

class Arcadios(SpriteManager):

    def __init__(self, position):
        SpriteManager.__init__(self)

        self.loadSprites()
        self.defaultSurface(self.move_right)
        self.initialPosition(position[0],position[1])
        self.velocity = 4
        self.angle = 0
        

    def loadSprites(self):

        self.move_right = self.getAnimation('game/intro/images/arcadio1', 'right', True)

    
    def ia(self):
        
        self.angleMove(40, self.angle)

        self.angle+=10

        self.surface = self.animate(self.move_right)

    def controls(self, controls):
        pass

